unit uRealToBytes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    eEin: TEdit;
    bGibaus: TButton;
    lX: TLabel;
    lB: TLabel;
    eBbin: TEdit;
    procedure bGibausClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bGibausClick(Sender: TObject);
type
  Tbyte4 = array[1..4] of byte;
var
  x : single;
  b : Tbyte4 absolute x; // b liegt an der gleichen Adresse wie x

  function ByteToBin(b : byte) : string;
  var
    i : byte;
    s : string;
  begin
    // Sonderfall b = 0 behandeln
    if b = 0 then s := '00000000' else s := '';
    // Ausgabestring aufbauen
    while b > 0 do
    begin
      if odd(b) then s := '1'+s else s := '0'+s; // Ziffer vorne anfgen
      b := b div 2;
    end;
    // fhrende Nullen ergnzen
    while length(s) < 8 do s := '0'+s;
    // Ergebnisrckgabe
    result := s;
  end;

begin
  x := StrToFloat(eEin.Text);

  // b := Tbyte4(x);  // Typumwandlung, TypeCast

  eBbin.Text := ByteToBin(b[1])+'  '+ByteToBin(b[2])+'  '+
                ByteToBin(b[3])+'  '+ByteToBin(b[4]);
end;

end.
